/*
  fcfs_updateobj.c
  -------------
  
  Real nasty stuff that tries to do updates to objects.
  I'm quaking in my boots doing this kinda stuff.

  $Id: fcfs_updateobj.c,v 1.1 2003/09/30 12:56:25 stewart Exp $
  
  (C)2003 Stewart Smith
  Distributed under the GPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>


#include "testkit/block_dev.h"
#include "testkit/types.h"
#include "testkit/bitops.h"
#include "disk.h"

#include "super_block.h"
#include "onode.h"
#include "onode_index.h"
#include "space_bitmap.h"
#include "fcfs_vfs.h"

#define EXPERIMENTAL

int main(int argc, char* argv[])
{
  struct fcfs_disk* disk;
  struct fcfs_onode_index* index;
  int i;

  if(argc<3)
    {
      fprintf(stderr,"fcfs_newobj\n");
      fprintf(stderr,"-----------\n");
      fprintf(stderr,"$Id: fcfs_updateobj.c,v 1.1 2003/09/30 12:56:25 stewart Exp $\n");
      fprintf(stderr,"Usage:\n");
      fprintf(stderr,"\t%s volume file offset length onode_id\n\n",argv[0]);
      exit(1);
    }

  disk = fcfs_mount(argv[1]);

  index = onode_index_read(disk);

  {
    struct fcfs_onode1 *onode;
    struct fcfs_disk_block *onode_block;
    struct fcfs_block_run onode_br;
    char *data; int j;
    int infile;
    int rlen;
    struct stat statbuf;

    onode_block = onode_index_lookup(index, &onode_br,atoi(argv[5]));
    onode = (struct fcfs_onode1*)onode_block->data;

    infile = open(argv[2],O_RDONLY);
    fstat(infile,&statbuf);
    lseek(infile,atoi(argv[3]),SEEK_SET);

    fprintf(stderr,"+++++++GOING TO GO AND WRITE %s++++++++\n",argv[3]);

    data = (char*)malloc(sizeof(char)*atoi(argv[4]));

    j=0;
    rlen = read(infile,data,atoi(argv[4]));
    fprintf(stderr,"*******WRITING %d bytes*******\n",rlen);
    onode1_fork_write_versioned(disk,onode,&onode_br,1,atoi(argv[3]),(u64)rlen,data);
    
    close(infile);
    free(onode);
    free(data);
  }  
  
  fcfs_umount(disk);

  return 0;
}
