/* onode_versioned.h
   -----------------

   Data structures for versioned onode forks,
   keeps track of the revision log.

   $Id: onode_versioned.h,v 1.2 2003/10/20 07:18:11 stewart Exp $

   (C)2003 Stewart Smith
   Distributed under the GNU GPL
*/

#ifndef __ONODE_VERSIONED_H__
#define __ONODE_VERSIONED_H__

#include "testkit/types.h"

enum fcfs_onode_fork_rev_op {
  FCFS_ONODE_FORK_REV_REPLACE,
  FCFS_ONODE_FORK_REV_INSERT,
  FCFS_ONODE_FORE_REV_APPEND,
  FCFS_ONODE_FORK_REV_TRUNCATE,
  FCFS_ONODE_FORK_REV_GROW,
};

#define FCFS_ONODE_FORK_REV_MAGIC1 0xF0526B76	/* 0xF0 'R' 'k' 'v' */

struct fcfs_onode_fork_rev {
  u64 revision;			/* Increment for each revision */
  u64 consistent_revision;	/* Used to note last consistent revision */
  u64 time;			/* Time revision was done (not committed) */
  u32 operation;		/* enum fcfs_onode_fork_rev_op */
  u32 magic1;			/* FCFS_ONODE_FORK_REV_MAGIC1 */
  u64 rev_offset;		/* Offset in revision fork */
  u64 rev_length;		/* Length of revision fork data */
  u64 offset;			/* Offset in real fork to apply to*/
  char space[16];		/* Space for future revisions */
};

#endif
